Create expenses and queue for sync
curl --request POST \
--url https://api.sync2books.com/expenses/{connectionId} \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
[
{
"id": "<string>",
"type": "Payment",
"issueDate": "2023-11-07T05:31:56Z",
"currency": "USD",
"currencyRate": 123,
"merchantName": "<string>",
"lines": [
{
"netAmount": 123,
"taxAmount": 123,
"taxRateRef": {
"id": "<string>",
"name": "<string>"
},
"accountRef": {
"id": "<string>",
"name": "<string>"
},
"trackingRefs": [
{
"id": "<string>",
"dataType": "<string>"
}
],
"invoiceTo": {
"id": "<string>",
"type": "<string>"
}
}
],
"contactRef": {
"id": "<string>",
"type": "<string>"
},
"notes": "<string>",
"postAsDraft": false
}
]
'import requests
url = "https://api.sync2books.com/expenses/{connectionId}"
payload = [
{
"id": "<string>",
"type": "Payment",
"issueDate": "2023-11-07T05:31:56Z",
"currency": "USD",
"currencyRate": 123,
"merchantName": "<string>",
"lines": [
{
"netAmount": 123,
"taxAmount": 123,
"taxRateRef": {
"id": "<string>",
"name": "<string>"
},
"accountRef": {
"id": "<string>",
"name": "<string>"
},
"trackingRefs": [
{
"id": "<string>",
"dataType": "<string>"
}
],
"invoiceTo": {
"id": "<string>",
"type": "<string>"
}
}
],
"contactRef": {
"id": "<string>",
"type": "<string>"
},
"notes": "<string>",
"postAsDraft": False
}
]
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify([
{
id: '<string>',
type: 'Payment',
issueDate: '2023-11-07T05:31:56Z',
currency: 'USD',
currencyRate: 123,
merchantName: '<string>',
lines: [
{
netAmount: 123,
taxAmount: 123,
taxRateRef: {id: '<string>', name: '<string>'},
accountRef: {id: '<string>', name: '<string>'},
trackingRefs: [{id: '<string>', dataType: '<string>'}],
invoiceTo: {id: '<string>', type: '<string>'}
}
],
contactRef: {id: '<string>', type: '<string>'},
notes: '<string>',
postAsDraft: false
}
])
};
fetch('https://api.sync2books.com/expenses/{connectionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.sync2books.com/expenses/{connectionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
[
'id' => '<string>',
'type' => 'Payment',
'issueDate' => '2023-11-07T05:31:56Z',
'currency' => 'USD',
'currencyRate' => 123,
'merchantName' => '<string>',
'lines' => [
[
'netAmount' => 123,
'taxAmount' => 123,
'taxRateRef' => [
'id' => '<string>',
'name' => '<string>'
],
'accountRef' => [
'id' => '<string>',
'name' => '<string>'
],
'trackingRefs' => [
[
'id' => '<string>',
'dataType' => '<string>'
]
],
'invoiceTo' => [
'id' => '<string>',
'type' => '<string>'
]
]
],
'contactRef' => [
'id' => '<string>',
'type' => '<string>'
],
'notes' => '<string>',
'postAsDraft' => false
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.sync2books.com/expenses/{connectionId}"
payload := strings.NewReader("[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.sync2books.com/expenses/{connectionId}")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.sync2books.com/expenses/{connectionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]"
response = http.request(request)
puts response.read_body{
"syncBatchId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"totalExpenses": 123
}Expenses
Create expenses and queue for sync
Always takes an array, even for a single expense.
POST
/
expenses
/
{connectionId}
Create expenses and queue for sync
curl --request POST \
--url https://api.sync2books.com/expenses/{connectionId} \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
[
{
"id": "<string>",
"type": "Payment",
"issueDate": "2023-11-07T05:31:56Z",
"currency": "USD",
"currencyRate": 123,
"merchantName": "<string>",
"lines": [
{
"netAmount": 123,
"taxAmount": 123,
"taxRateRef": {
"id": "<string>",
"name": "<string>"
},
"accountRef": {
"id": "<string>",
"name": "<string>"
},
"trackingRefs": [
{
"id": "<string>",
"dataType": "<string>"
}
],
"invoiceTo": {
"id": "<string>",
"type": "<string>"
}
}
],
"contactRef": {
"id": "<string>",
"type": "<string>"
},
"notes": "<string>",
"postAsDraft": false
}
]
'import requests
url = "https://api.sync2books.com/expenses/{connectionId}"
payload = [
{
"id": "<string>",
"type": "Payment",
"issueDate": "2023-11-07T05:31:56Z",
"currency": "USD",
"currencyRate": 123,
"merchantName": "<string>",
"lines": [
{
"netAmount": 123,
"taxAmount": 123,
"taxRateRef": {
"id": "<string>",
"name": "<string>"
},
"accountRef": {
"id": "<string>",
"name": "<string>"
},
"trackingRefs": [
{
"id": "<string>",
"dataType": "<string>"
}
],
"invoiceTo": {
"id": "<string>",
"type": "<string>"
}
}
],
"contactRef": {
"id": "<string>",
"type": "<string>"
},
"notes": "<string>",
"postAsDraft": False
}
]
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify([
{
id: '<string>',
type: 'Payment',
issueDate: '2023-11-07T05:31:56Z',
currency: 'USD',
currencyRate: 123,
merchantName: '<string>',
lines: [
{
netAmount: 123,
taxAmount: 123,
taxRateRef: {id: '<string>', name: '<string>'},
accountRef: {id: '<string>', name: '<string>'},
trackingRefs: [{id: '<string>', dataType: '<string>'}],
invoiceTo: {id: '<string>', type: '<string>'}
}
],
contactRef: {id: '<string>', type: '<string>'},
notes: '<string>',
postAsDraft: false
}
])
};
fetch('https://api.sync2books.com/expenses/{connectionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.sync2books.com/expenses/{connectionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
[
'id' => '<string>',
'type' => 'Payment',
'issueDate' => '2023-11-07T05:31:56Z',
'currency' => 'USD',
'currencyRate' => 123,
'merchantName' => '<string>',
'lines' => [
[
'netAmount' => 123,
'taxAmount' => 123,
'taxRateRef' => [
'id' => '<string>',
'name' => '<string>'
],
'accountRef' => [
'id' => '<string>',
'name' => '<string>'
],
'trackingRefs' => [
[
'id' => '<string>',
'dataType' => '<string>'
]
],
'invoiceTo' => [
'id' => '<string>',
'type' => '<string>'
]
]
],
'contactRef' => [
'id' => '<string>',
'type' => '<string>'
],
'notes' => '<string>',
'postAsDraft' => false
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.sync2books.com/expenses/{connectionId}"
payload := strings.NewReader("[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.sync2books.com/expenses/{connectionId}")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.sync2books.com/expenses/{connectionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "[\n {\n \"id\": \"<string>\",\n \"type\": \"Payment\",\n \"issueDate\": \"2023-11-07T05:31:56Z\",\n \"currency\": \"USD\",\n \"currencyRate\": 123,\n \"merchantName\": \"<string>\",\n \"lines\": [\n {\n \"netAmount\": 123,\n \"taxAmount\": 123,\n \"taxRateRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"accountRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"trackingRefs\": [\n {\n \"id\": \"<string>\",\n \"dataType\": \"<string>\"\n }\n ],\n \"invoiceTo\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n }\n }\n ],\n \"contactRef\": {\n \"id\": \"<string>\",\n \"type\": \"<string>\"\n },\n \"notes\": \"<string>\",\n \"postAsDraft\": false\n }\n]"
response = http.request(request)
puts response.read_body{
"syncBatchId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"totalExpenses": 123
}Authorizations
Your application's API key (sk_development_… or sk_production_…). An optional X-Signature / X-Timestamp HMAC pair may additionally be sent for stronger security — see Authentication.
Path Parameters
The connection to the accounting system to write through.
Body
application/json
Minimum array length:
1Your own identifier for this expense.
Example:
"Payment"
Example:
"USD"
Minimum array length:
1Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes